package cn.efunbox.base.enums;

import java.util.HashSet;
import java.util.Set;

public enum BaseStatusEnum {

    NORMAL("正常"),ABNORMAL("不正常");

    /**
     * 未删除 需要在列表查询
     */
    public static Set<BaseStatusEnum>  show = new HashSet<>();

    static {
        show.add(BaseStatusEnum.NORMAL);
    }

    public static BaseStatusEnum getBaseStatusEnum(Integer value) {
    	 switch (value) {
         case 0:
             return NORMAL;
         case 1:
             return ABNORMAL;
         default:
             return null;
     }
    }  
    String name;
    BaseStatusEnum(String name) {
        this.name = name;  
    }
      
    public String getName() {  
        return name;  
    }
    @Override
    public String toString() {
        return this.name;
    }

}  