package cn.efunbox.base.util;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

/**
 * CurrentWeekUtil
 * Created by xusq on 2018/1/30.
 */
public class CurrentWeekUtil {

    public static int currentWeek(){

        Calendar c = Calendar.getInstance();
//        c.add(Calendar.DATE,7);

        int currentWeek = c.get(Calendar.WEEK_OF_YEAR);
        int year = c.get(Calendar.YEAR);

        int weekNumber = year * 100 + currentWeek;

        return  weekNumber;
    }

    public static List<Integer> getWeekDay(int weekNum){
        Calendar c = Calendar.getInstance();
        c.setFirstDayOfWeek(Calendar.SATURDAY);
        c.set(Calendar.YEAR, weekNum/100);
        c.set(Calendar.WEEK_OF_YEAR, weekNum%100);
        c.set(Calendar.DAY_OF_WEEK, c.getFirstDayOfWeek());
        SimpleDateFormat sdf=new SimpleDateFormat("d");
        List<Integer> dayList = new ArrayList<>();
        for (int i = 0 ; i < 7 ; i++) {
            c.add(Calendar.DAY_OF_WEEK, 1);
            dayList.add(Integer.valueOf(sdf.format(c.getTime())));
        }
        return dayList;
    }

    public static void main(String[] args) {
        List<Integer> i = CurrentWeekUtil.getWeekDay(201836);
        System.out.println(i);
        int i1 = CurrentWeekUtil.currentWeek();
        System.out.println(i1);

//        String s = UUID.randomUUID().toString();
//        System.out.println(s);
//        String s1 = UUID.randomUUID().toString();
//        System.out.println(s1);
    }
}
